import os
import json

from binarycpython.utils.grid import Population
from binarycpython.utils.functions import get_help_all, get_help


test_pop = Population()

## Setting values
# print(test_pop.bse_options['M_1'])
# print(test_pop.bse_options['M_2'])
# test_pop.set(M_1=10, M_2=500)
# print(test_pop.bse_options['M_1'])
# print(test_pop.bse_options['M_2'])
test_pop.set(
    M_1=10,
    separation=0,
    orbital_period=4580,
    max_evolution_time=15000,
    eccentricity=0.02,
)
# print(test_pop.bse_options)

## Testing single evolution
# test_pop.evolve_single()
# test_pop.test_evolve_single()

## Setting custom value
# test_pop.set(data_dir=os.path.join(os.environ['BINARYC_DATA_ROOT'], 'development_example'))
# print(test_pop.custom_options['data_dir'])

## printing all options
# print(json.dumps(test_pop.return_population_settings(), indent=4))

## return arglines:
# test_pop.set(M_1=10, M_2=500)
# print(test_pop.return_argline())
# test_pop.return_argline()

## return version info
# version_info = test_pop.return_binary_c_version_info()
# print(version_info)

## Use custom arg file
# test_pop.evolve_population(custom_arg_file='/home/david/projects/binary_c_root/binary_c-python/tests/population/custom_arg_file.txt')

## Custom logging:
# test_pop.set(C_auto_logging={'MY_HEADER_LINE': ['star[0].mass', 'star[1].mass', 'model.probability']})
# test_pop.set(C_logging_code='Printf("MY_STELLAR_DATA time=%g mass=%g radius=%g\\n", stardata->model.time, stardata->star[0].mass, stardata->star[0].radius);')
# test_pop.evolve_population()


## Custom logging with bigger print statement:
test_pop.set(M_1=100, M_2=1, metallicity=0.0002, orbital_period=500000000)
test_pop.set(C_logging_code="""
    if(stardata->star[0].stellar_type>=MS)
    {
        if (stardata->model.time < stardata->model.max_evolution_time)
        {
            Printf("DAVID_SCO %30.12e %g %g %g %g %d %d\\n",
                // 
                stardata->model.time, // 1

                stardata->star[0].mass, //2
                stardata->previous_stardata->star[0].mass, //3

                stardata->star[0].radius, //4
                stardata->previous_stardata->star[0].radius, //5

                stardata->star[0].stellar_type, //6
                stardata->previous_stardata->star[0].stellar_type //7
          );
        };
        /* Kill the simulation to save time */
        //stardata->model.max_evolution_time = stardata->model.time - stardata->model.dtm;
    };
""")
test_pop.evolve_population()


## Help all
# print(get_help_all(return_dict=True))

# get_help_all()
# print(get_help('M_1', print_help=False, return_dict=True))


# return all info:
# print(json.dumps(test_pop.return_all_info(), indent=4))
test_pop.export_all_info(outfile=os.path.join(os.getcwd(), "test_output.txt"))